/*
 * rcp.java - Remote Copy utility
 *
 * Copyright (c) 2000 Cogito, LLC 
 *
 * Cogito grants you ("Licensee") a non-exclusive, royalty free, license to
 * use, modify and redistribute this software in source and binary form,
 * provided that i) this copyright notice and license appear on all copies
 * of the software; and ii) Licensee does not utilize the software in a
 * manner which is disparaging to Cogito.
 *
 * This software is provided "AS IS," without warranty of any kind.
 *
 * 12/2000: Initial version.
 *          M. Tim Jones <mtj@cogitollc.com>
 *
 */

import java.io.*;
import java.net.*;

public class rcp {

  public static void main(String args[]) {

    String remoteArg = new String();
    Socket theSocket;
    PrintStream out;
    DataInputStream in;
    String input;
    int i, fileSize = 0;
    byte word, checksum, calcsum = 0;
    byte[] recvFile;

    if (args.length != 2) {
      System.out.println("\nUsage is:");
      System.out.println("\trcp <server> <subdir+filename>\n");
      System.exit(1);
    }

    remoteArg = "$get " + args[1];

    try {
      theSocket = new Socket(args[0], 15000);
      in = new DataInputStream(theSocket.getInputStream());
      out = new PrintStream(theSocket.getOutputStream());

      try {
        out.print(remoteArg);
        out.flush();

        // Wait for the file size
        input = in.readLine();
        if (input != null) {

          fileSize = Integer.parseInt(input);

          recvFile = new byte[fileSize];

          in.readFully(recvFile, 0, fileSize);
          for (i = 0 ; i < fileSize ; i++) calcsum += recvFile[i];

// Code for HEX ASCII input of file stream...
//          for ( i = 0 ; i < fileSize ; i++ ) {
//            input = in.readLine();
//            word = (byte)Integer.parseInt(input);
//            recvFile[i] = word;
//            calcsum = (byte)((calcsum + word) & 0xff);
//          }

          // Wait for the checksum
          input = in.readLine();
          checksum = (byte)Integer.parseInt(input);

          if (calcsum != checksum) {
            System.err.println("Bad file transfer.");
          } else {

            FileOutputStream fileOut = 
              new FileOutputStream(
                    args[1].substring(args[1].lastIndexOf('/')+1, 
                                       args[1].length()));

            try {
              fileOut.write(recvFile);
              fileOut.close();
            } catch (IOException e) {
              System.err.println("Couldn't write file." + e);
            }

          }

        } else {
          System.err.println("Remote file does not exist");
        }

      } catch (IOException e) {
        System.err.println("Error conversing with the server.");
      }

      out.close();
      in.close();
      theSocket.close();

    } catch (IOException e) {
      System.err.println("Couldn't connect to the server.");
      System.exit(1);
    }

  }

}
